<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class BotPluginMetadata extends \Google\Protobuf\Internal\Message
{
    


    protected $provider = null;
    


    protected $pluginType = null;
    


    protected $thumbnailCdnUrl = null;
    


    protected $profilePhotoCdnUrl = null;
    


    protected $searchProviderUrl = null;
    


    protected $referenceIndex = null;
    


    protected $expectedLinksCount = null;
    


    protected $searchQuery = null;
    


    protected $parentPluginMessageKey = null;
    


    protected $deprecatedField = null;
    


    protected $parentPluginType = null;
    


    protected $faviconCdnUrl = null;

    



















    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getProvider()
    {
        return isset($this->provider) ? $this->provider : 0;
    }

    public function hasProvider()
    {
        return isset($this->provider);
    }

    public function clearProvider()
    {
        unset($this->provider);
    }

    




    public function setProvider($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotPluginMetadata\SearchProvider::class);
        $this->provider = $var;

        return $this;
    }

    



    public function getPluginType()
    {
        return isset($this->pluginType) ? $this->pluginType : 0;
    }

    public function hasPluginType()
    {
        return isset($this->pluginType);
    }

    public function clearPluginType()
    {
        unset($this->pluginType);
    }

    




    public function setPluginType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotPluginMetadata\PluginType::class);
        $this->pluginType = $var;

        return $this;
    }

    



    public function getThumbnailCdnUrl()
    {
        return isset($this->thumbnailCdnUrl) ? $this->thumbnailCdnUrl : '';
    }

    public function hasThumbnailCdnUrl()
    {
        return isset($this->thumbnailCdnUrl);
    }

    public function clearThumbnailCdnUrl()
    {
        unset($this->thumbnailCdnUrl);
    }

    




    public function setThumbnailCdnUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->thumbnailCdnUrl = $var;

        return $this;
    }

    



    public function getProfilePhotoCdnUrl()
    {
        return isset($this->profilePhotoCdnUrl) ? $this->profilePhotoCdnUrl : '';
    }

    public function hasProfilePhotoCdnUrl()
    {
        return isset($this->profilePhotoCdnUrl);
    }

    public function clearProfilePhotoCdnUrl()
    {
        unset($this->profilePhotoCdnUrl);
    }

    




    public function setProfilePhotoCdnUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->profilePhotoCdnUrl = $var;

        return $this;
    }

    



    public function getSearchProviderUrl()
    {
        return isset($this->searchProviderUrl) ? $this->searchProviderUrl : '';
    }

    public function hasSearchProviderUrl()
    {
        return isset($this->searchProviderUrl);
    }

    public function clearSearchProviderUrl()
    {
        unset($this->searchProviderUrl);
    }

    




    public function setSearchProviderUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->searchProviderUrl = $var;

        return $this;
    }

    



    public function getReferenceIndex()
    {
        return isset($this->referenceIndex) ? $this->referenceIndex : 0;
    }

    public function hasReferenceIndex()
    {
        return isset($this->referenceIndex);
    }

    public function clearReferenceIndex()
    {
        unset($this->referenceIndex);
    }

    




    public function setReferenceIndex($var)
    {
        GPBUtil::checkUint32($var);
        $this->referenceIndex = $var;

        return $this;
    }

    



    public function getExpectedLinksCount()
    {
        return isset($this->expectedLinksCount) ? $this->expectedLinksCount : 0;
    }

    public function hasExpectedLinksCount()
    {
        return isset($this->expectedLinksCount);
    }

    public function clearExpectedLinksCount()
    {
        unset($this->expectedLinksCount);
    }

    




    public function setExpectedLinksCount($var)
    {
        GPBUtil::checkUint32($var);
        $this->expectedLinksCount = $var;

        return $this;
    }

    



    public function getSearchQuery()
    {
        return isset($this->searchQuery) ? $this->searchQuery : '';
    }

    public function hasSearchQuery()
    {
        return isset($this->searchQuery);
    }

    public function clearSearchQuery()
    {
        unset($this->searchQuery);
    }

    




    public function setSearchQuery($var)
    {
        GPBUtil::checkString($var, True);
        $this->searchQuery = $var;

        return $this;
    }

    



    public function getParentPluginMessageKey()
    {
        return $this->parentPluginMessageKey;
    }

    public function hasParentPluginMessageKey()
    {
        return isset($this->parentPluginMessageKey);
    }

    public function clearParentPluginMessageKey()
    {
        unset($this->parentPluginMessageKey);
    }

    




    public function setParentPluginMessageKey($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\MessageKey::class);
        $this->parentPluginMessageKey = $var;

        return $this;
    }

    



    public function getDeprecatedField()
    {
        return isset($this->deprecatedField) ? $this->deprecatedField : 0;
    }

    public function hasDeprecatedField()
    {
        return isset($this->deprecatedField);
    }

    public function clearDeprecatedField()
    {
        unset($this->deprecatedField);
    }

    




    public function setDeprecatedField($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotPluginMetadata\PluginType::class);
        $this->deprecatedField = $var;

        return $this;
    }

    



    public function getParentPluginType()
    {
        return isset($this->parentPluginType) ? $this->parentPluginType : 0;
    }

    public function hasParentPluginType()
    {
        return isset($this->parentPluginType);
    }

    public function clearParentPluginType()
    {
        unset($this->parentPluginType);
    }

    




    public function setParentPluginType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\BotPluginMetadata\PluginType::class);
        $this->parentPluginType = $var;

        return $this;
    }

    



    public function getFaviconCdnUrl()
    {
        return isset($this->faviconCdnUrl) ? $this->faviconCdnUrl : '';
    }

    public function hasFaviconCdnUrl()
    {
        return isset($this->faviconCdnUrl);
    }

    public function clearFaviconCdnUrl()
    {
        unset($this->faviconCdnUrl);
    }

    




    public function setFaviconCdnUrl($var)
    {
        GPBUtil::checkString($var, True);
        $this->faviconCdnUrl = $var;

        return $this;
    }

}

